--- Mesa-7.8.2/src/mesa/glapi/gen/glX_proto_send.py.orig	2010-06-16 03:43:42.000000000 +1000
+++ Mesa-7.8.2/src/mesa/glapi/gen/glX_proto_send.py	2010-12-06 15:18:38.000000000 +1100
@@ -161,40 +161,40 @@
 		return
 
 	def printRealHeader(self):
-		print ''
-		print '#include <GL/gl.h>'
-		print '#include "indirect.h"'
-		print '#include "glxclient.h"'
-		print '#include "indirect_size.h"'
-		print '#include "glapidispatch.h"'
-		print '#include "glapi.h"'
-		print '#include "glthread.h"'
-		print '#include <GL/glxproto.h>'
-		print '#ifdef USE_XCB'
-		print '#include <X11/Xlib-xcb.h>'
-		print '#include <xcb/xcb.h>'
-		print '#include <xcb/glx.h>'
-		print '#endif /* USE_XCB */'
-
-		print ''
-		print '#define __GLX_PAD(n) (((n) + 3) & ~3)'
-		print ''
+		print ('')
+		print ('#include <GL/gl.h>')
+		print ('#include "indirect.h"')
+		print ('#include "glxclient.h"')
+		print ('#include "indirect_size.h"')
+		print ('#include "glapidispatch.h"')
+		print ('#include "glapi.h"')
+		print ('#include "glthread.h"')
+		print ('#include <GL/glxproto.h>')
+		print ('#ifdef USE_XCB')
+		print ('#include <X11/Xlib-xcb.h>')
+		print ('#include <xcb/xcb.h>')
+		print ('#include <xcb/glx.h>')
+		print ('#endif /* USE_XCB */')
+
+		print ('')
+		print ('#define __GLX_PAD(n) (((n) + 3) & ~3)')
+		print ('')
 		self.printFastcall()
 		self.printNoinline()
-		print ''
-		print '#ifndef __GNUC__'
-		print '#  define __builtin_expect(x, y) x'
-		print '#endif'
-		print ''
-		print '/* If the size and opcode values are known at compile-time, this will, on'
-		print ' * x86 at least, emit them with a single instruction.'
-		print ' */'
-		print '#define emit_header(dest, op, size)            \\'
-		print '    do { union { short s[2]; int i; } temp;    \\'
-		print '         temp.s[0] = (size); temp.s[1] = (op); \\'
-		print '         *((int *)(dest)) = temp.i; } while(0)'
-		print ''
-		print """NOINLINE CARD32
+		print ('')
+		print ('#ifndef __GNUC__')
+		print ('#  define __builtin_expect(x, y) x')
+		print ('#endif')
+		print ('')
+		print ('/* If the size and opcode values are known at compile-time, this will, on')
+		print (' * x86 at least, emit them with a single instruction.')
+		print (' */')
+		print ('#define emit_header(dest, op, size)            \\')
+		print ('    do { union { short s[2]; int i; } temp;    \\')
+		print ('         temp.s[0] = (size); temp.s[1] = (op); \\')
+		print ('         *((int *)(dest)) = temp.i; } while(0)')
+		print ('')
+		print ("""NOINLINE CARD32
 __glXReadReply( Display *dpy, size_t size, void * dest, GLboolean reply_is_always_array )
 {
     xGLXSingleReply reply;
@@ -306,7 +306,7 @@
 #define default_pixel_store_3D_size 36
 #define default_pixel_store_4D      (__glXDefaultPixelStore+0)
 #define default_pixel_store_4D_size 36
-"""
+""")
 
 		for size in self.generic_sizes:
 			self.print_generic_function(size)
@@ -357,9 +357,9 @@
 	def printFunction(self, func, name):
 		footer = '}\n'
 		if func.glx_rop == ~0:
-			print 'static %s' % (func.return_type)
-			print '%s( unsigned opcode, unsigned dim, %s )' % (func.name, func.get_parameter_string())
-			print '{'
+			print ('static %s' % (func.return_type))
+			print ('%s( unsigned opcode, unsigned dim, %s )' % (func.name, func.get_parameter_string()))
+			print ('{')
 		else:
 			if func.has_different_protocol(name):
 				if func.return_type == "void":
@@ -368,24 +368,24 @@
 					ret_string = "return "
 
 				func_name = func.static_glx_name(name)
-				print '#define %s %d' % (func.opcode_vendor_name(name), func.glx_vendorpriv)
-				print '%s gl%s(%s)' % (func.return_type, func_name, func.get_parameter_string())
-				print '{'
-				print '    __GLXcontext * const gc = __glXGetCurrentContext();'
-				print ''
-				print '#ifdef GLX_DIRECT_RENDERING'
-				print '    if (gc->driContext) {'
-				print '    %sCALL_%s(GET_DISPATCH(), (%s));' % (ret_string, func.name, func.get_called_parameter_string())
-				print '    } else'
-				print '#endif'
-				print '    {'
+				print ('#define %s %d' % (func.opcode_vendor_name(name), func.glx_vendorpriv))
+				print ('%s gl%s(%s)' % (func.return_type, func_name, func.get_parameter_string()))
+				print ('{')
+				print ('    __GLXcontext * const gc = __glXGetCurrentContext();')
+				print ('')
+				print ('#ifdef GLX_DIRECT_RENDERING')
+				print ('    if (gc->driContext) {')
+				print ('    %sCALL_%s(GET_DISPATCH(), (%s));' % (ret_string, func.name, func.get_called_parameter_string()))
+				print ('    } else')
+				print ('#endif')
+				print ('    {')
 
 				footer = '}\n}\n'
 			else:
-				print '#define %s %d' % (func.opcode_name(), func.opcode_value())
+				print ('#define %s %d' % (func.opcode_name(), func.opcode_value()))
 
-				print '%s __indirect_gl%s(%s)' % (func.return_type, name, func.get_parameter_string())
-				print '{'
+				print ('%s __indirect_gl%s(%s)' % (func.return_type, name, func.get_parameter_string()))
+				print ('{')
 
 
 		if func.glx_rop != 0 or func.vectorequiv != None:
@@ -397,15 +397,15 @@
 			self.printSingleFunction(func, name)
 			pass
 		else:
-			print "/* Missing GLX protocol for %s. */" % (name)
+			print ("/* Missing GLX protocol for %s. */" % (name))
 
-		print footer
+		print (footer)
 		return
 
 
 	def print_generic_function(self, n):
 		size = (n + 3) & ~3
-		print """static FASTCALL NOINLINE void
+		print ("""static FASTCALL NOINLINE void
 generic_%u_byte( GLint rop, const void * ptr )
 {
     __GLXcontext * const gc = __glXGetCurrentContext();
@@ -416,7 +416,7 @@
     gc->pc += cmdlen;
     if (__builtin_expect(gc->pc > gc->limit, 0)) { (void) __glXFlushRenderBuffer(gc, gc->pc); }
 }
-""" % (n, size + 4, size)
+""" % (n, size + 4, size))
 		return
 
 
@@ -427,14 +427,14 @@
 			src_ptr = "&" + p.name
 
 		if p.is_padding:
-			print '(void) memset((void *)(%s + %u), 0, %s);' \
-			    % (pc, p.offset + adjust, p.size_string() )
+			print ('(void) memset((void *)(%s + %u), 0, %s);' \
+			    % (pc, p.offset + adjust, p.size_string() ))
 		elif not extra_offset:
-			print '(void) memcpy((void *)(%s + %u), (void *)(%s), %s);' \
-			    % (pc, p.offset + adjust, src_ptr, p.size_string() )
+			print ('(void) memcpy((void *)(%s + %u), (void *)(%s), %s);' \
+			    % (pc, p.offset + adjust, src_ptr, p.size_string() ))
 		else:
-			print '(void) memcpy((void *)(%s + %u + %s), (void *)(%s), %s);' \
-			    % (pc, p.offset + adjust, extra_offset, src_ptr, p.size_string() )
+			print ('(void) memcpy((void *)(%s + %u + %s), (void *)(%s), %s);' \
+			    % (pc, p.offset + adjust, extra_offset, src_ptr, p.size_string() ))
 
 	def common_emit_args(self, f, pc, adjust, skip_vla):
 		extra_offset = None
@@ -470,7 +470,7 @@
 				self.common_emit_one_arg(param, pc, adjust, None)
 
 				if f.pad_after(param):
-					print '(void) memcpy((void *)(%s + %u), zero, 4);' % (pc, (param.offset + param.size()) + adjust)
+					print ('(void) memcpy((void *)(%s + %u), zero, 4);' % (pc, (param.offset + param.size()) + adjust))
 
 			else:
 				[dim, width, height, depth, extent] = param.get_dimensions()
@@ -480,14 +480,14 @@
 					dim_str = str(dim)
 
 				if param.is_padding:
-					print '(void) memset((void *)(%s + %u), 0, %s);' \
-					% (pc, (param.offset - 4) + adjust, param.size_string() )
+					print ('(void) memset((void *)(%s + %u), 0, %s);' \
+					% (pc, (param.offset - 4) + adjust, param.size_string() ))
 
 				if param.img_null_flag:
 					if large:
-						print '(void) memcpy((void *)(%s + %u), zero, 4);' % (pc, (param.offset - 4) + adjust)
+						print ('(void) memcpy((void *)(%s + %u), zero, 4);' % (pc, (param.offset - 4) + adjust))
 					else:
-						print '(void) memcpy((void *)(%s + %u), (void *)((%s == NULL) ? one : zero), 4);' % (pc, (param.offset - 4) + adjust, param.name)
+						print ('(void) memcpy((void *)(%s + %u), (void *)((%s == NULL) ? one : zero), 4);' % (pc, (param.offset - 4) + adjust, param.name))
 
 
 				pixHeaderPtr = "%s + %u" % (pc, adjust)
@@ -499,13 +499,13 @@
 					else:
 						condition = 'compsize > 0'
 
-					print 'if (%s) {' % (condition)
-					print '    (*gc->fillImage)(gc, %s, %s, %s, %s, %s, %s, %s, %s, %s);' % (dim_str, width, height, depth, param.img_format, param.img_type, param.name, pcPtr, pixHeaderPtr)
-					print '} else {'
-					print '    (void) memcpy( %s, default_pixel_store_%uD, default_pixel_store_%uD_size );' % (pixHeaderPtr, dim, dim)
-					print '}'
+					print ('if (%s) {' % (condition))
+					print ('    (*gc->fillImage)(gc, %s, %s, %s, %s, %s, %s, %s, %s, %s);' % (dim_str, width, height, depth, param.img_format, param.img_type, param.name, pcPtr, pixHeaderPtr))
+					print ('} else {')
+					print ('    (void) memcpy( %s, default_pixel_store_%uD, default_pixel_store_%uD_size );' % (pixHeaderPtr, dim, dim))
+					print ('}')
 				else:
-					print '__glXSendLargeImage(gc, compsize, %s, %s, %s, %s, %s, %s, %s, %s, %s);' % (dim_str, width, height, depth, param.img_format, param.img_type, param.name, pcPtr, pixHeaderPtr)
+					print ('__glXSendLargeImage(gc, compsize, %s, %s, %s, %s, %s, %s, %s, %s, %s);' % (dim_str, width, height, depth, param.img_format, param.img_type, param.name, pcPtr, pixHeaderPtr))
 
 		return
 
@@ -514,16 +514,16 @@
 		if not op_name:
 			op_name = f.opcode_real_name()
 
-		print 'const GLint op = %s;' % (op_name)
-		print 'const GLuint cmdlenLarge = cmdlen + 4;'
-		print 'GLubyte * const pc = __glXFlushRenderBuffer(gc, gc->pc);'
-		print '(void) memcpy((void *)(pc + 0), (void *)(&cmdlenLarge), 4);'
-		print '(void) memcpy((void *)(pc + 4), (void *)(&op), 4);'
+		print ('const GLint op = %s;' % (op_name))
+		print ('const GLuint cmdlenLarge = cmdlen + 4;')
+		print ('GLubyte * const pc = __glXFlushRenderBuffer(gc, gc->pc);')
+		print ('(void) memcpy((void *)(pc + 0), (void *)(&cmdlenLarge), 4);')
+		print ('(void) memcpy((void *)(pc + 4), (void *)(&op), 4);')
 		return
 
 
 	def common_func_print_just_start(self, f, name):
-		print '    __GLXcontext * const gc = __glXGetCurrentContext();'
+		print ('    __GLXcontext * const gc = __glXGetCurrentContext();')
 
 		# The only reason that single and vendor private commands need
 		# a variable called 'dpy' is becuase they use the SyncHandle
@@ -541,10 +541,10 @@
 		if not f.glx_rop:
 			for p in f.parameterIterateOutputs():
 				if p.is_image() and (p.img_format != "GL_COLOR_INDEX" or p.img_type != "GL_BITMAP"):
-					print '    const __GLXattribute * const state = gc->client_state_private;'
+					print ('    const __GLXattribute * const state = gc->client_state_private;')
 					break
 
-			print '    Display * const dpy = gc->currentDpy;'
+			print ('    Display * const dpy = gc->currentDpy;')
 			skip_condition = "dpy != NULL"
 		elif f.can_be_large:
 			skip_condition = "gc->currentDpy != NULL"
@@ -553,26 +553,26 @@
 
 
 		if f.return_type != 'void':
-			print '    %s retval = (%s) 0;' % (f.return_type, f.return_type)
+			print ('    %s retval = (%s) 0;' % (f.return_type, f.return_type))
 
 
 		if name != None and name not in f.glx_vendorpriv_names:
-			print '#ifndef USE_XCB'
+			print ('#ifndef USE_XCB')
 		self.emit_packet_size_calculation(f, 0)
 		if name != None and name not in f.glx_vendorpriv_names:
-			print '#endif'
+			print ('#endif')
 
 		condition_list = []
 		for p in f.parameterIterateCounters():
 			condition_list.append( "%s >= 0" % (p.name) )
 			# 'counter' parameters cannot be negative
-			print "    if (%s < 0) {" % p.name
-			print "        __glXSetError(gc, GL_INVALID_VALUE);"
+			print ("    if (%s < 0) {" % p.name)
+			print ("        __glXSetError(gc, GL_INVALID_VALUE);")
 			if f.return_type != 'void':
-				print "        return 0;"
+				print ("        return 0;")
 			else:
-				print "        return;"
-			print "    }"
+				print ("        return;")
+			print ("    }")
 
 		if skip_condition:
 			condition_list.append( skip_condition )
@@ -583,7 +583,7 @@
 			else:
 				skip_condition = "%s" % (condition_list.pop(0))
 
-			print '    if (__builtin_expect(%s, 1)) {' % (skip_condition)
+			print ('    if (__builtin_expect(%s, 1)) {' % (skip_condition))
 			return 1
 		else:
 			return 0
@@ -593,16 +593,16 @@
 		self.common_func_print_just_start(f, name)
 
 		if self.debug:
-			print '        printf( "Enter %%s...\\n", "gl%s" );' % (f.name)
+			print ('        printf( "Enter %%s...\\n", "gl%s" );' % (f.name))
 
 		if name not in f.glx_vendorpriv_names:
 
 			# XCB specific:
-			print '#ifdef USE_XCB'
+			print ('#ifdef USE_XCB')
 			if self.debug:
-				print '        printf("\\tUsing XCB.\\n");'
-			print '        xcb_connection_t *c = XGetXCBConnection(dpy);'
-			print '        (void) __glXFlushRenderBuffer(gc, gc->pc);'
+				print ('        printf("\\tUsing XCB.\\n");')
+			print ('        xcb_connection_t *c = XGetXCBConnection(dpy);')
+			print ('        (void) __glXFlushRenderBuffer(gc, gc->pc);')
 			xcb_name = 'xcb_glx%s' % convertStringForXCB(name)
 
 			iparams=[]
@@ -629,24 +629,24 @@
 			xcb_request = '%s(%s)' % (xcb_name, ", ".join(["c", "gc->currentContextTag"] + iparams + extra_iparams))
 
 			if f.needs_reply():
-				print '        %s_reply_t *reply = %s_reply(c, %s, NULL);' % (xcb_name, xcb_name, xcb_request)
+				print ('        %s_reply_t *reply = %s_reply(c, %s, NULL);' % (xcb_name, xcb_name, xcb_request))
 				if output and f.reply_always_array:
-					print '        (void)memcpy(%s, %s_data(reply), %s_data_length(reply) * sizeof(%s));' % (output.name, xcb_name, xcb_name, output.get_base_type_string())
+					print ('        (void)memcpy(%s, %s_data(reply), %s_data_length(reply) * sizeof(%s));' % (output.name, xcb_name, xcb_name, output.get_base_type_string()))
 
 				elif output and not f.reply_always_array:
 					if not output.is_image():
-						print '        if (%s_data_length(reply) == 0)' % (xcb_name)
-						print '            (void)memcpy(%s, &reply->datum, sizeof(reply->datum));' % (output.name)
-						print '        else'
-					print '        (void)memcpy(%s, %s_data(reply), %s_data_length(reply) * sizeof(%s));' % (output.name, xcb_name, xcb_name, output.get_base_type_string())
+						print ('        if (%s_data_length(reply) == 0)' % (xcb_name))
+						print ('            (void)memcpy(%s, &reply->datum, sizeof(reply->datum));' % (output.name))
+						print ('        else')
+					print ('        (void)memcpy(%s, %s_data(reply), %s_data_length(reply) * sizeof(%s));' % (output.name, xcb_name, xcb_name, output.get_base_type_string()))
 
 
 				if f.return_type != 'void':
-					print '        retval = reply->ret_val;'
-				print '        free(reply);'
+					print ('        retval = reply->ret_val;')
+				print ('        free(reply);')
 			else:
-				print '        ' + xcb_request + ';'
-			print '#else'
+				print ('        ' + xcb_request + ';')
+			print ('#else')
 			# End of XCB specific.
 
 
@@ -656,9 +656,9 @@
 			pc_decl = "(void)"
 
 		if name in f.glx_vendorpriv_names:
-			print '        %s __glXSetupVendorRequest(gc, %s, %s, cmdlen);' % (pc_decl, f.opcode_real_name(), f.opcode_vendor_name(name))
+			print ('        %s __glXSetupVendorRequest(gc, %s, %s, cmdlen);' % (pc_decl, f.opcode_real_name(), f.opcode_vendor_name(name)))
 		else:
-			print '        %s __glXSetupSingleRequest(gc, %s, cmdlen);' % (pc_decl, f.opcode_name())
+			print ('        %s __glXSetupSingleRequest(gc, %s, cmdlen);' % (pc_decl, f.opcode_name()))
 
 		self.common_emit_args(f, "pc", 0, 0)
 
@@ -667,12 +667,12 @@
 		for img in images:
 			if img.is_output:
 				o = f.command_fixed_length() - 4
-				print '        *(int32_t *)(pc + %u) = 0;' % (o)
+				print ('        *(int32_t *)(pc + %u) = 0;' % (o))
 				if img.img_format != "GL_COLOR_INDEX" or img.img_type != "GL_BITMAP":
-					print '        * (int8_t *)(pc + %u) = state->storePack.swapEndian;' % (o)
+					print ('        * (int8_t *)(pc + %u) = state->storePack.swapEndian;' % (o))
 		
 				if f.img_reset:
-					print '        * (int8_t *)(pc + %u) = %s;' % (o + 1, f.img_reset)
+					print ('        * (int8_t *)(pc + %u) = %s;' % (o + 1, f.img_reset))
 
 
 		return_name = ''
@@ -689,9 +689,9 @@
 				if p.is_image():
 					[dim, w, h, d, junk] = p.get_dimensions()
 					if f.dimensions_in_reply:
-						print "        __glXReadPixelReply(dpy, gc, %u, 0, 0, 0, %s, %s, %s, GL_TRUE);" % (dim, p.img_format, p.img_type, p.name)
+						print ("        __glXReadPixelReply(dpy, gc, %u, 0, 0, 0, %s, %s, %s, GL_TRUE);" % (dim, p.img_format, p.img_type, p.name))
 					else:
-						print "        __glXReadPixelReply(dpy, gc, %u, %s, %s, %s, %s, %s, %s, GL_FALSE);" % (dim, w, h, d, p.img_format, p.img_type, p.name)
+						print ("        __glXReadPixelReply(dpy, gc, %u, %s, %s, %s, %s, %s, %s, GL_FALSE);" % (dim, w, h, d, p.img_format, p.img_type, p.name))
 
 					got_reply = 1
 				else:
@@ -711,7 +711,7 @@
 					# non-arrays) gives us this.
 
 					s = p.size() / p.get_element_count()
-					print "       %s __glXReadReply(dpy, %s, %s, %s);" % (return_str, s, p.name, aa)
+					print ("       %s __glXReadReply(dpy, %s, %s, %s);" % (return_str, s, p.name, aa))
 					got_reply = 1
 
 
@@ -719,25 +719,25 @@
 			# read a NULL reply to get the return value.
 
 			if not got_reply:
-				print "       %s __glXReadReply(dpy, 0, NULL, GL_FALSE);" % (return_str)
+				print ("       %s __glXReadReply(dpy, 0, NULL, GL_FALSE);" % (return_str))
 
 
 		elif self.debug:
 			# Only emit the extra glFinish call for functions
 			# that don't already require a reply from the server.
-			print '        __indirect_glFinish();'
+			print ('        __indirect_glFinish();')
 
 		if self.debug:
-			print '        printf( "Exit %%s.\\n", "gl%s" );' % (name)
+			print ('        printf( "Exit %%s.\\n", "gl%s" );' % (name))
 
 
-		print '        UnlockDisplay(dpy); SyncHandle();'
+		print ('        UnlockDisplay(dpy); SyncHandle();')
 
 		if name not in f.glx_vendorpriv_names:
-			print '#endif /* USE_XCB */'
+			print ('#endif /* USE_XCB */')
 
-		print '    }'
-		print '    return%s;' % (return_name)
+		print ('    }')
+		print ('    return%s;' % (return_name))
 		return
 
 
@@ -761,7 +761,7 @@
 				if f.pad_after(param):
 					p_string += ", 1"
 
-			print '    %s(%s, %u%s );' % (self.pixel_stubs[f.name] , f.opcode_name(), dim, p_string)
+			print ('    %s(%s, %u%s );' % (self.pixel_stubs[f.name] , f.opcode_name(), dim, p_string))
 			return
 
 
@@ -772,32 +772,32 @@
 
 
 		if f.can_be_large:
-			print 'if (cmdlen <= gc->maxSmallRenderCommandSize) {'
-			print '    if ( (gc->pc + cmdlen) > gc->bufEnd ) {'
-			print '        (void) __glXFlushRenderBuffer(gc, gc->pc);'
-			print '    }'
+			print ('if (cmdlen <= gc->maxSmallRenderCommandSize) {')
+			print ('    if ( (gc->pc + cmdlen) > gc->bufEnd ) {')
+			print ('        (void) __glXFlushRenderBuffer(gc, gc->pc);')
+			print ('    }')
 
 		if f.glx_rop == ~0:
 			opcode = "opcode"
 		else:
 			opcode = f.opcode_real_name()
 
-		print 'emit_header(gc->pc, %s, cmdlen);' % (opcode)
+		print ('emit_header(gc->pc, %s, cmdlen);' % (opcode))
 
 		self.pixel_emit_args( f, "gc->pc", 0 )
-		print 'gc->pc += cmdlen;'
-		print 'if (gc->pc > gc->limit) { (void) __glXFlushRenderBuffer(gc, gc->pc); }'
+		print ('gc->pc += cmdlen;')
+		print ('if (gc->pc > gc->limit) { (void) __glXFlushRenderBuffer(gc, gc->pc); }')
 
 		if f.can_be_large:
-			print '}'
-			print 'else {'
+			print ('}')
+			print ('else {')
 
 			self.large_emit_begin(f, opcode)
 			self.pixel_emit_args(f, "pc", 1)
 
-			print '}'
+			print ('}')
 
-		if trailer: print trailer
+		if trailer: print (trailer)
 		return
 
 
@@ -814,7 +814,7 @@
 			if p.is_pointer():
 				cmdlen = f.command_fixed_length()
 				if cmdlen in self.generic_sizes:
-					print '    generic_%u_byte( %s, %s );' % (cmdlen, f.opcode_real_name(), p.name)
+					print ('    generic_%u_byte( %s, %s );' % (cmdlen, f.opcode_real_name(), p.name))
 					return
 
 		if self.common_func_print_just_start(f, None):
@@ -823,36 +823,36 @@
 			trailer = None
 
 		if self.debug:
-			print 'printf( "Enter %%s...\\n", "gl%s" );' % (f.name)
+			print ('printf( "Enter %%s...\\n", "gl%s" );' % (f.name))
 
 		if f.can_be_large:
-			print 'if (cmdlen <= gc->maxSmallRenderCommandSize) {'
-			print '    if ( (gc->pc + cmdlen) > gc->bufEnd ) {'
-			print '        (void) __glXFlushRenderBuffer(gc, gc->pc);'
-			print '    }'
+			print ('if (cmdlen <= gc->maxSmallRenderCommandSize) {')
+			print ('    if ( (gc->pc + cmdlen) > gc->bufEnd ) {')
+			print ('        (void) __glXFlushRenderBuffer(gc, gc->pc);')
+			print ('    }')
 
-		print 'emit_header(gc->pc, %s, cmdlen);' % (f.opcode_real_name())
+		print ('emit_header(gc->pc, %s, cmdlen);' % (f.opcode_real_name()))
 
 		self.common_emit_args(f, "gc->pc", 4, 0)
-		print 'gc->pc += cmdlen;'
-		print 'if (__builtin_expect(gc->pc > gc->limit, 0)) { (void) __glXFlushRenderBuffer(gc, gc->pc); }'
+		print ('gc->pc += cmdlen;')
+		print ('if (__builtin_expect(gc->pc > gc->limit, 0)) { (void) __glXFlushRenderBuffer(gc, gc->pc); }')
 
 		if f.can_be_large:
-			print '}'
-			print 'else {'
+			print ('}')
+			print ('else {')
 
 			self.large_emit_begin(f)
 			self.common_emit_args(f, "pc", 8, 1)
 
 			p = f.variable_length_parameter()
-			print '    __glXSendLargeCommand(gc, pc, %u, %s, %s);' % (p.offset + 8, p.name, p.size_string())
-			print '}'
+			print ('    __glXSendLargeCommand(gc, pc, %u, %s, %s);' % (p.offset + 8, p.name, p.size_string()))
+			print ('}')
 
 		if self.debug:
-			print '__indirect_glFinish();'
-			print 'printf( "Exit %%s.\\n", "gl%s" );' % (f.name)
+			print ('__indirect_glFinish();')
+			print ('printf( "Exit %%s.\\n", "gl%s" );' % (f.name))
 
-		if trailer: print trailer
+		if trailer: print (trailer)
 		return
 
 
@@ -868,7 +868,7 @@
 
 
 	def printRealHeader(self):
-		print """/**
+		print ("""/**
  * \\file indirect_init.c
  * Initialize indirect rendering dispatch table.
  *
@@ -918,7 +918,7 @@
 		print """
     return glAPI;
 }
-"""
+""")
 		return
 
 
@@ -931,7 +931,7 @@
 
 			for func in api.functionIterateByCategory(name):
 				if func.client_supported_for_indirect():
-					print '%s    glAPI->%s = __indirect_gl%s;' % (preamble, func.name, func.name)
+					print ('%s    glAPI->%s = __indirect_gl%s;' % (preamble, func.name, func.name))
 					preamble = ''
 
 		return
@@ -952,19 +952,19 @@
 
 
 	def printRealHeader(self):
-		print """/**
+		print ("""/**
  * \\file
  * Prototypes for indirect rendering functions.
  *
  * \\author Kevin E. Martin <kevin@precisioninsight.com>
  * \\author Ian Romanick <idr@us.ibm.com>
  */
-"""
+""")
 		self.printVisibility( "HIDDEN", "hidden" )
 		self.printFastcall()
 		self.printNoinline()
 
-		print """
+		print ("""
 #include "glxclient.h"
 
 extern HIDDEN NOINLINE CARD32 __glXReadReply( Display *dpy, size_t size,
@@ -980,31 +980,31 @@
 
 extern HIDDEN NOINLINE FASTCALL GLubyte * __glXSetupVendorRequest(
     __GLXcontext * gc, GLint code, GLint vop, GLint cmdlen );
-"""
+""")
 
 
 	def printBody(self, api):
 		for func in api.functionIterateGlx():
 			params = func.get_parameter_string()
 
-			print 'extern HIDDEN %s __indirect_gl%s(%s);' % (func.return_type, func.name, params)
+			print ('extern HIDDEN %s __indirect_gl%s(%s);' % (func.return_type, func.name, params))
 
 			for n in func.entry_points:
 				if func.has_different_protocol(n):
 					asdf = func.static_glx_name(n)
 					if asdf not in func.static_entry_points:
-						print 'extern HIDDEN %s gl%s(%s);' % (func.return_type, asdf, params)
+						print ('extern HIDDEN %s gl%s(%s);' % (func.return_type, asdf, params))
 					else:
-						print 'GLAPI %s GLAPIENTRY gl%s(%s);' % (func.return_type, asdf, params)
+						print ('GLAPI %s GLAPIENTRY gl%s(%s);' % (func.return_type, asdf, params))
 						
 					break
 
 
 
 def show_usage():
-	print "Usage: %s [-f input_file_name] [-m output_mode] [-d]" % sys.argv[0]
-	print "    -m output_mode   Output mode can be one of 'proto', 'init_c' or 'init_h'."
-	print "    -d               Enable extra debug information in the generated code."
+	print ("Usage: %s [-f input_file_name] [-m output_mode] [-d]" % sys.argv[0])
+	print ("    -m output_mode   Output mode can be one of 'proto', 'init_c' or 'init_h'.")
+	print ("    -d               Enable extra debug information in the generated code.")
 	sys.exit(1)
 
 
